import { createBridge } from "./setup";
import * as THREE from "three";
import { 
alertAsync
,confirmAsync 
,choiceAsync
,promptAsync
} from "./dialogUtil";

export function createWorldObjects({
  scene,
  collisionObjects,
  _interactableObjects,
  teleportTargetObjects,
}) {
  //移動可能地形
  {
    const o = createBridge();
    o.rotateY(180 * (Math.PI / 180));
    o.position.set(1, 0.1, -1.5);
    scene.add(o);
    teleportTargetObjects.push(o);
  }

  //移動可能地形
  {
    const box = new THREE.Mesh(
      new THREE.BoxGeometry(3, 0.5, 1),
      new THREE.MeshLambertMaterial({
        color: 0x00ff00,
        side: THREE.DoubleSide,
      })
    );
    box.name = "box-g";
    box.position.set(2, 0.75, 5);
    //クリックイベントの設定
    box.onSelectDown = async () =>{
      alertAsync("移動可能な地形に入ると垂直位置が地形の上に設定されます。");
    }
    window.arr_interactive.push(box);
    scene.add(box);
    teleportTargetObjects.push(box);
  }

  //移動可能地形
  {
    const box = new THREE.Mesh(
      new THREE.BoxGeometry(1, 0.5, 3),
      new THREE.MeshLambertMaterial({
        color: 0x0000ff,
        side: THREE.DoubleSide,
      })
    );
    box.name = "box-b";
    box.position.set(0, 0.25, 5);
    scene.add(box);
    teleportTargetObjects.push(box);
  }

  //移動可能地形
  {
    const box = new THREE.Mesh(
      new THREE.BoxGeometry(1, 0.5, 3),
      new THREE.MeshLambertMaterial({
        color: 0x0000ff,
        side: THREE.DoubleSide,
      })
    );
    box.name = "box-b2";
    box.position.set(3, 1.25, 5);
    //クリックイベントの設定
    box.onSelectDown = async () =>{
      alertAsync("段差が一定以上ある場合は侵入できません。");
    }
    window.arr_interactive.push(box);

    scene.add(box);
    teleportTargetObjects.push(box);
  }





  //障害物
  {
    const wall = new THREE.Mesh(
      new THREE.PlaneGeometry(10, 3, 1, 1),
      new THREE.MeshLambertMaterial({
        color: 0xff0000,
        side: THREE.DoubleSide,
      })
    );
    wall.name = "wall-r";
    wall.position.set(-2, 0.5, 0);
    wall.rotation.y = Math.PI / 2;
    scene.add(wall);
    collisionObjects.push(wall);
  }


}
